xecho "log" "" "Loading \[CHANNEL\] overlay..."

proc xdcc_chanparse { type towho passed } {
	if { $passed == "" } {
		dccsimul $towho ".help xdcc chan"
		return 0
	}

	set parsethis [lindex $passed 0]
	switch [string tolower $parsethis] {
		"add"	{
				xdcc_chan_add $type $towho [lrange $passed 1 end]
				return 0
			}
		"del"	{
				xdcc_chan_del $type $towho [lrange $passed 1 end]
				return 0
			}
		"list"	{
				xdcc_chan_list $type $towho [lrange $passed 1 end]
				return 0
			}
	}
}

proc xdcc_chan_list { type towho passed } {
	global xdcc_channels xdcc_channel_file xdcc_avalible
	
	if { $xdcc_avalible == "0" } {
		xecho $type $towho "Sorry, XDCC isn't active right now."
		return 0
	}
	
	if { [file exist $xdcc_channel_file] != "1" } {
		xecho $type $towho "No channels to list!"
		return 0
	}

	xecho $type $towho "Channel list:"
	set counter 0
	set ch_fid [open $xdcc_channel_file r]

	if { $xdcc_channels == "0" } {
		xecho $type $towho "Sorry, there are no channels to list!"
		return 0
	}
	while { $counter != $xdcc_channels } {
		incr counter
		gets $ch_fid temp_chaname
		xecho $type $towho "$counter : $temp_chaname"
	}
	close $ch_fid
}

proc xdcc_chan_add { type towho passed } {
	global xdcc_channel_file xdcc_channels

	if { $passed == "" } {
		dccsimul $towho ".help xdcc chan add"
		return 0
	}
	if { [string first "#" $passed] != "0" } {
		dccsimul $towho ".help xdcc chan add"
		return 0
	}

	set chanlist [channels]

	if { [string first $passed $chanlist] == "-1" } {
		xecho $type $towho "Sorry, I'm not in channel $passed, so I can't offer to it. :("
		return 0
	}
	
	set c_fid [open $xdcc_channel_file a]
	puts $c_fid $passed

	incr xdcc_channels

	close $c_fid
	xecho $type $towho "Added $passed to channel list."
	xecho $type $towho "You are now offering to $xdcc_channels channel\(s\)"

}

proc xdcc_chan_del { type towho passed } {
	global xdcc_channels xdcc_channel_file xdcc_temp_file
	
	if { $passed == "" } {
		dccsimul $towho ".help xdcc chan del"
		return 0
	}
	if { [regexp {^[0-9]+$} $passed] != "1" } {
		dccsimul $towho ".help xdcc chan del"
		return 0
	}
	
	set counter 0
	set c_fid [open $xdcc_channel_file r]
	set t_fid [open $xdcc_temp_file w]
	
	while { $counter != $xdcc_channels } {
		incr counter
		if { $counter == $passed } {
			gets $c_fid garbage
		}
		if { $counter != $passed } {
			gets $c_fid temp_chname
			puts $t_fid $temp_chname
		}
	}
	close $c_fid
	close $t_fid
	
	set c_fid [open $xdcc_channel_file w]
	set t_fid [open $xdcc_temp_file r]
	
	while { [eof $t_fid] != "1" } {
		gets $t_fid temp_chname
		puts $c_fid $temp_chname
	}
	close $c_fid
	close $t_fid
	set xdcc_channels [expr $xdcc_channels - 1]

	if { $xdcc_channels == "0" } {
		set tmp [open "|rm $xdcc_channel_file"]
	}
	
	xecho $type $towho "Channel number \[$passed\] \($garbage\) has been removed!"
}

xecho "log" "" "OK"
