xecho "log" "" "Loading \[USERS\] Overlay...."

proc xdcc_send { type towho passed } {
	global xdcc_offers xdcc_offer_file xdcc_default_dir xdcc_avalible
	global botnick

	if { $xdcc_avalible == "0" } {
		xecho $type $towho "Sorry, I'm not offering any files right now."
		return 0
	}
	if { $passed == "" } {
		xecho $type $towho "Incorrect XDCC SEND Syntax. /MSG $botnick HELP XDCC for help."
		return 0
	}
	if { [string index $passed 0] == "#" } {
		set pack_number [string trim $passed "#"]
	}
	if { [string index $passed 0] != "#" } {
		set pack_number $passed
	}
	if { [regexp {^[0-9]+$} $pack_number] != "1" } {
		xecho $type $towho "Incorrect XDCC SEND Syntax. /MSG $botnick HELP XDCC for help."
		return 0
	}
	if { $pack_number > $xdcc_offers } {
		xecho $type $towho "Sorry, I'm not offering a pack numbered $xdcc_offers"
		xecho $type $towho "/msg $botnick XDCC LIST to retrieve a pack listing."
		return 0
	}

	set counter 0
	set o_id [open $xdcc_offer_file r]
	
	while { [eof $o_id] != "1" } {
		incr counter
		
		if { $counter == $pack_number } {
			gets $o_id files
			gets $o_id size
			gets $o_id desc
			gets $o_id note
		}
		if { $counter != $pack_number } {
			gets $o_id garbage
			gets $o_id garbage
			gets $o_id garbage
			gets $o_id garbage
		}
	}

	set fullpath [append fullpath $xdcc_default_dir $files]	
	set filelist [glob $fullpath]

	set counter 1
	set pcounter 0
	xecho $type $towho "Sending you $desc, wich is about $size \(approx\)"
	if { $counter == [llength $filelist] } {
		set filename [lindex $filelist 0]
		catch { send_file $type $towho $filename } status
		if { $status == 2 } {
			close $o_id
			return 0
		}
	}

	while { $counter != [llength $filelist] } {
		incr counter
		set filename [lindex $filelist $pcounter]

		if { [file isdirectory $filename] == 0 } {
			catch { send_file $type $towho $filename } status
			if { $status == 2 } {
				close $o_id
				return 0
			}
		}

		incr pcounter
	}
	close $o_id
}

proc send_file { type towho filename } {


	catch { dccsend $filename $towho } status

	switch $status { 
		"0" 	{
				return 0
			}
		"1"	{
				xecho $type $towho "Sorry, I've got way to many DCC Sends going on right now."
				xecho $type $towho "Please try back later tho. :)"
				return 2
			}
		"2"	{
				xecho $type $towho "Uh-oh, I apparently have something wrong with my network layer."
				xecho $type $towho "I can't seem to open a socket for filetransfer. There really isn't"
				xecho $type $towho "you or I can do about this. I'll let my master know about it."
				return 2
			}
		"3"	{
				xecho $type $towho "Ummm... I can't seem to find the file that's part of the pack you requested."
				xecho $type $towho "I apologize for the inconveniance, and I will remove the pack from my list now."
				xecho $type $towho "I'm also going to have a very strong word with my master. this kind of stuff"
				xecho $type $towho "shouldn't be happening!"
				return 2
			}
		"4"	{
				xecho $type $towho "I can't send you file $filename right away, unfortunatly you've got to many"
				xecho $type $towho "DCC Transfers with me going right now. Once one of them are compleated, I'll"
				xecho $type $towho "automatically send the file to you. Thank you for your patience."
				return 0
			}
	}
}